use vars qw(@ISA @EXPORT);
use Exporter;
use Time::Local 'timelocal';

@ISA = qw(Exporter);
@EXPORT = qw(quit_chat enter_chat enter_channel read_chat);

sub grep_message_random {
  my $reason = shift;

  my @reasons;

  srand;

  open (FILE, "./$reason-$language.txt") || die print "Nie moglem otworzyc pliku  $reason-$language.txt poniewaz : $!\n";
  @reasons = <FILE>;

  $random = rand(scalar(@reasons));

  return($reasons[$random]);
}

sub grep_message_all {
  my $reason = shift;

  my @messages;

  open (FILE, "./$reason-$language.txt") || die print "Nie moglem otworzyc pliku $reason-$language.txt poniewaz : $!\n";
  @messages = <FILE>;

  return(@messages);
}

sub quit_chat {
  my $chat = shift;

  $quit_message = grep_message_random(2);

  print $chat "*CLOSE\n";
  sleep($time_to_wait);
  print $chat "*CLOSE\n";

  close($chat);
}

sub enter_chat {
  my ($chat, $bot_nick) = @_;

  print $chat "*LANG\n";
  print $chat "*LOGIN|SYSTEM|$bot_nick|$bot_pass|$kanal|#000000|\n";
  print $chat "*MSG|$bot_nick|CHAN|Witam wszystkich:)|#000000|\n";
  print "kChatBoT polaczony z $server\n";
}

sub greet_someone {
  my ($chat, $n, $type) = @_;

  my $greet = grep_message_random(3);
  chomp($greet);

  sleep($time_to_wait);
  if ($type == 1) {			# Private
    print $chat "*MSG|$bot_nick|$name|$greet|black|\n";
  }
  elsif ($type == 0) {			# All
    print $chat "*MSG|$bot_nick|CHAN|$greet $n|black|\n";
  }
}

sub ttime {
	local($hour);
	local($minute);
	local($second);
	local($time);
	($second,$minute,$hour) = localtime(time);
	$time = "$hour:$minute:$second";
	return $time;
}

sub tdate {
	local($day);
	local($month);
	local($year);
	local($date);
	($day,$month,$year) = localtime(time);
	$time = "$day/$month/$year";
	return $date;
}

sub flame_someone {
  my ($chat, $n, $type) = @_;

  my $flame = grep_message_random(5);
  chomp($flame);

  sleep($time_to_wait);
  if ($type == 1) {			# Private
    print $chat "SAY $n $flame\n";
  }
  elsif ($type == 0) {
   print $chat "*MODERATOR|$mod_pass|none|\n";
    print $chat "*KICK|$n|\n";
    print $chat "*NOMODERATOR\n";
  }
}

sub someone_talk_about_me {
  my $chat = shift;

  my $message = grep_message_random(6);
  chomp($message);

  sleep($time_to_wait);
  print $chat "SAY $message\n";
}

sub check_badword {
  my ($chat, $message, $n, $type) = @_;

  my ($done, $i, @bad_words, $badword);

  @bad_words = grep_message_all(4);
  for ($i = 0; $i < $#bad_words; $i++) {
    $badword = $bad_words[$i];
    chomp($badword);
    if (($message =~ /$badword/i) && ($done != 1)) {
      $done = 1;
      flame_someone($chat, $n, $type);
    }
  }

  return($done);
}

sub accept_command {
  my ($chat, $num, $type) = @_;
  print "PRIV $name wykonuje komende:  \"$type\"...\n";
}

sub read_chat {
  my ($chat, $text) = @_;

  my ($done, $num, $name, $message);
  chomp($text);

   if ($text =~ /\*MSG\|(.*)\|$bot_nick\|!(.*)\|(.*)\|/) {
    $name	= $1;
    $message	= $2;
    $color	 = $3;

    my $done	= 0;

    my ($greet, $badword);
    my (@greets, @bad_words);

    @greets = grep_message_all(3);
    for ($i = 0; $i < $#greets; $i++) {
      $greet = $greets[$i];
      chomp($greet);
      if (($message =~ /$greet[ ,]+$bot_nick.*/i) || ($message =~ /$bot_nick.*$greet.*/i)) {
	$done = 1;
	if ($bot_nick =~ /$name/i) {
	  sleep($time_to_wait);
	}
	else {
	  greet_someone($chat, $name, 0);
	}
      }
    }
    if ($done == 0) {
      $done = check_badword($chat, $message, $name, 0);
    }
    if ($message =~ /version/i) {
      print $chat "*MSG|$bot_nick|$name|kChatBoT v0.2 for kChat|#000000|\n";
	    print "USER $name wyswietla wersje\n";
    }
    if ($message =~ /autor/i) {
      print $chat "*MSG|$bot_nick|$name|(c) 2002 gladiator . All rights reserved.|#000000|\n";
	    print "USER $name wyswietla autora\n";
    }
    if ($message =~ /home/i) {
      print $chat "*MSG|$bot_nick|$name|http://c-portal.prv.pl|#000000|\n";
	    print "USER $name wyswietla strone\n";
    }
      if ($message =~ /time/i) {
     $time=&ttime($time);
      print $chat "*MSG|$bot_nick|$name|Aktualny czas: $time|#000000|\n";
	    print "USER $name sprawdza czas\n";
    }
    if ($message =~ /joins/i) {
      print $chat "*MSG|$bot_nick|$name|Osob weszlo: $j|#000000|\n";
	    print "USER $name ile osob weszlo [$j]\n";
    }
    if ($message =~ /browar (.*)/i) {
	  $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Stawiam browarek dla $nick od uzytkownika $name|#000000\|\n";
	    print "USER $name stawia browat userowi $nick\n";
    }
   if ($message =~ /winko (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Stawiam TTaANniIeE VViNNkO dla $nick od uzytkownika $name|#000000|\n";
	    print "USER $name stawia winko userowi $nick\n";
    }
    if ($message =~ /coke (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje wirtualna cole dla $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia cole userowi $nick\n";
      }
    if ($message =~ /pepsi (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje wirtualna pepsi $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia pepsi userowi $nick\n";
    }
    if ($message =~ /setka (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Polewa setke czystej wodki dla $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia setke userowi $nick\n";
    }
    if ($message =~ /blant (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje blanta uzytkownikowi $nick od uzytkownika $name|#000000|\n";
       print "USER $name podaje blanta $nick\n";
    }

    if ($message =~ /bobofrut (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje wirtualny wyskokowy napoj 'bobofrut' dla $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia bobofruta userowi $nick\n";
    }
    if ($message =~ /help/i) {
      print $chat "*MSG|$bot_nick|$name|Komendy dla uzytkownikow.|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  1. !autor - wyswietla autora bot'a |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  2. !browar <nick> - stawia browarek uzytkownikowi <nick>|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  3. !home - wyswietla ulubiona stronke bot'a|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  4. !version - wyswietla wersje bot'a|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  5. !winko <nick> - stawia 'tanie winko' uzytkownikowi <nick>|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  6. !pepsi <nick> - podaje wirtualna pepsi uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  7. !coke <nick> - podaje wirtualna cole uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  8. !bobofrut <nick> - podaje wirtualny bobofrut uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  9. !setka <nick> - podaje setke czystej wodki uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name| 10. !blant <nick> - podaje blant'a uzytkownikowi <nick> <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name| 11. !time - podaje czas bot'a|#000000|\n";
       print "USER $name wyswietla zwyklego helpa\n";
    }
  }
  elsif ($text =~ /\*MSG\|(.*)\|$bot_nick\|(.*)\|(.*)\|/) {
    $name	= $1;
    $message	= $2;
    $color	= $3;
    if ($message =~ /$admin_pass (.*)/) {   # dla ludzi ktorzy znaja haslo, moga pisac botowi na privie: "haslo !komenda"
      if ($message =~ /!quit/) {
	accept_command($chat, $num, "quit");
	print "disconnecting by $name\n";
	quit_chat($chat);
      }
      elsif ($message =~ /!reconnect/) {
	accept_command($chat, $num, "reconnect");
	quit_chat($chat);
	print "reconnecting by $name ... (please wait)\n";
	Main();
      }
       elsif ($message =~ /!say (.*)/) {
	$tekst = $1;
	print $chat "*MSG|$bot_nick|CHAN|$tekst|#000000|\n";
	print "SAY $tekst [$name]\n";
      }
      elsif ($message =~ /!topic (.*)/) {
	$tekst = $1;
	print $chat "*MODERATOR|$mod_pass|none|\n";
	print $chat "*TOPIC|SET|$kanal|$tekst|\n";
	print "*NOMODERATOR\n";
      }

      elsif ($message =~ /!kick (.*)/) {
	$tekst = $1;
	print $chat "*MODERATOR|$mod_pass|none|\n";
	print $chat "*KICK|$tekst|\n";
	print "*NOMODERATOR\n";
      }

      elsif ($message =~ /!help/) {
	print $chat "*MSG|$bot_nick|$name| Komendy dla userow bot'a.|#000000|\n";
	print $chat "*MSG|$bot_nick|$name| 1. <haslo> !say <tekst> - wysyla tekst na ogolny|#000000|\n";
	print $chat "*MSG|$bot_nick|$name| 2. <haslo> !topic <tekst> - zmienia temat|#000000|\n";
	print $chat "*MSG|$bot_nick|$name| 3. <haslo> !kick <nick> - daje kicka wybrancowi ;-)|#000000|\n";
	print $chat "*MSG|$bot_nick|$name| 4. <haslo> !reconnect - restartuje bot'a|#000000|\n";
	print $chat "*MSG|$bot_nick|$name| 5. <haslo> !quit - zabija bot'a|#000000|\n";
	print "USER $name wglada w super help'a\n";
      }
      else {
	greet_someone($chat, $num, 1);
      }
    }
    else {
      my ($greet, @greets);

      @greets = grep_message_all(3);
      for ($i = 0; $i < $#greets; $i++) {
	$greet = $greets[$i];
	chomp($greet);
	if (($message =~ /$greet.*/i) || ($message =~ /$bot_nick.*$greet.*/i)) {
	  $done = 1;
	  greet_someone($chat, $num, 1);
	}
      }
      if ($done == 0) {
	$done = check_badword($chat, $message, $num, 1);
      }
      if ($done == 0) {
	sleep($time_to_wait);
	if ($bot_nick =~ /$name/i) {
	  print $chat "*PONG\n";
	}
	else {
	  print $chat "*PONG\n";
	}
      }
    }
  }

  elsif ($text =~ /\*MSG\|(.*)\|CHAN\|!(.*)\|(.*)\|/) {
    $name	= $1;
    $message   = $2;
    $color   = $3;

    my $done	= 0;

    my ($greet, $badword);
    my (@greets, @bad_words);

    @greets = grep_message_all(3);
    for ($i = 0; $i < $#greets; $i++) {
      $greet = $greets[$i];
      chomp($greet);
      if (($message =~ /$greet[ ,]+$bot_nick.*/i) || ($message =~ /$bot_nick.*$greet.*/i)) {
	$done = 1;
	if ($bot_nick =~ /$name/i) {
	  sleep($time_to_wait);
	}
	else {
	  greet_someone($chat, $name, 0);
	}
      }
    }
    if ($done == 0) {
      $done = check_badword($chat, $message, $name, 0);
    }
    if (($message =~ /$bot_nick/i) && ($done == 0)) {
      someone_talk_about_me($chat);
    }
    if ($message =~ /kick/i) {
	 print $chat "*MODERATOR|$mod_pass|none|\n";
	print $chat "*KICK|$name|\n";
	print $chat "*NOMODERATOR\n";
    }
	if ($message =~ /version/i) {
      print $chat "*MSG|$bot_nick|$name|kChatBoT v0.2 for kChat|#000000|\n";
	    print "USER $name wyswietla wersje\n";
    }
    if ($message =~ /autor/i) {
      print $chat "*MSG|$bot_nick|$name|(c) 2002 gladiator . All rights reserved.|#000000|\n";
	    print "USER $name wyswietla autora\n";
    }
    if ($message =~ /home/i) {
      print $chat "*MSG|$bot_nick|$name|http://c-portal.prv.pl|#000000|\n";
	    print "USER $name wyswietla strone\n";
    }
      if ($message =~ /time/i) {
     $time=&ttime($time);
      print $chat "*MSG|$bot_nick|$name|Aktualny czas: $time|#000000|\n";
	    print "USER $name sprawdza czas\n";
    }
    if ($message =~ /joins/i) {
      print $chat "*MSG|$bot_nick|$name|Osob weszlo: $j|#000000|\n";
	    print "USER $name ile osob weszlo [$j]\n";
    }
    if ($message =~ /browar (.*)/i) {
	  $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Stawiam browarek dla $nick od uzytkownika $name|#000000|\n";
	    print "USER $name stawia browat userowi $nick\n";
    }
   if ($message =~ /winko (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Stawiam TTaANniIeE VViNNkO dla $nick od uzytkownika $name|#000000|\n";
	    print "USER $name stawia winko userowi $nick\n";
    }
    if ($message =~ /coke (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje wirtualna cole dla $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia cole userowi $nick\n";
      }
    if ($message =~ /pepsi (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje wirtualna pepsi $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia pepsi userowi $nick\n";
    }
    if ($message =~ /setka (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Polewa setke czystej wodki dla $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia setke userowi $nick\n";
    }
    if ($message =~ /blant (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje blanta uzytkownikowi $nick od uzytkownika $name|#000000|\n";
       print "USER $name podaje blanta $nick\n";
    }

    if ($message =~ /bobofrut (.*)/i) {
       $nick  =  $1;
      print $chat "*MSG|$bot_nick|CHAN|Podaje wirtualny wyskokowy napoj 'bobofrut' dla $nick od uzytkownika $name|#000000|\n";
       print "USER $name stawia bobofruta userowi $nick\n";
    }
    if ($message =~ /help/i) {
      print $chat "*MSG|$bot_nick|$name|Komendy dla uzytkownikow.|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  1. !autor - wyswietla autora bot'a |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  2. !browar <nick> - stawia browarek uzytkownikowi <nick>|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  3. !home - wyswietla ulubiona stronke bot'a|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  4. !version - wyswietla wersje bot'a|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  5. !winko <nick> - stawia 'tanie winko' uzytkownikowi <nick>|#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  6. !pepsi <nick> - podaje wirtualna pepsi uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  7. !coke <nick> - podaje wirtualna cole uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  8. !bobofrut <nick> - podaje wirtualny bobofrut uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name|  9. !setka <nick> - podaje setke czystej wodki uzytkownikowi <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name| 10. !blant <nick> - podaje blant'a uzytkownikowi <nick> <nick> |#000000|\n";
      print $chat "*MSG|$bot_nick|$name| 11. !time - podaje czas bot'a|#000000|\n";
       print "USER $name wyswietla zwyklego helpa\n";
    }
  }
    elsif ($text =~ /\*MSG\|(.*)\|CHAN\|(.*)\|(.*)\|/) {
    $name	= $1;
    $message   = $2;
    $color   = $3;

    my $done	= 0;

    my ($greet, $badword);
    my (@greets, @bad_words);

    @greets = grep_message_all(3);
    for ($i = 0; $i < $#greets; $i++) {
      $greet = $greets[$i];
      chomp($greet);
      if (($message =~ /$greet[ ,]+$bot_nick.*/i) || ($message =~ /$bot_nick.*$greet.*/i)) {
	$done = 1;
	if ($bot_nick =~ /$name/i) {
	  sleep($time_to_wait);
	}
	else {
	  greet_someone($chat, $name, 0);
	}
      }
    }
    if ($done == 0) {
      $done = check_badword($chat, $message, $name, 0);
    }
    }



  elsif ($text =~ /\*KICK/) {
    $tekst = $1;
    print "reconnecting... (kicked) please wait...\n";
    Main();
  }
  elsif ($text =~ /\*PING/) {
    print $chat "\*PONG\n";
  }
}

1;
